package io.bdty.modules.cniyv.controller;

import io.bdty.common.annotation.LogOperation;
import io.bdty.common.constant.Constant;
import io.bdty.common.page.PageData;
import io.bdty.common.utils.ExcelUtils;
import io.bdty.common.utils.Result;
import io.bdty.common.validator.AssertUtils;
import io.bdty.common.validator.ValidatorUtils;
import io.bdty.common.validator.group.AddGroup;
import io.bdty.common.validator.group.DefaultGroup;
import io.bdty.common.validator.group.UpdateGroup;
import io.bdty.modules.cniyv.dto.CniyvArticleTypeDTO;
import io.bdty.modules.cniyv.excel.CniyvArticleTypeExcel;
import io.bdty.modules.cniyv.service.CniyvArticleTypeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;


/**
 * 文章分类
 *
 * @author zxj zxj
 * @since 1.0.0 2024-03-13
 */
@RestController
@RequestMapping("cniyv/cniyvarticletype")
@Api(tags="文章分类")
public class CniyvArticleTypeController {
    @Autowired
    private CniyvArticleTypeService cniyvArticleTypeService;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    public Result<PageData<CniyvArticleTypeDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<CniyvArticleTypeDTO> page = cniyvArticleTypeService.page(params);

        return new Result<PageData<CniyvArticleTypeDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("cniyv:cniyvarticletype:info")
    public Result<CniyvArticleTypeDTO> get(@PathVariable("id") Long id){
        CniyvArticleTypeDTO data = cniyvArticleTypeService.get(id);

        return new Result<CniyvArticleTypeDTO>().ok(data);
    }
    
    @GetMapping("info/{id}")
    @ApiOperation("详情")
    public Result<CniyvArticleTypeDTO> info(@PathVariable("id") Long id){
        CniyvArticleTypeDTO data = cniyvArticleTypeService.get(id);

        return new Result<CniyvArticleTypeDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("cniyv:cniyvarticletype:save")
    public Result save(@RequestBody CniyvArticleTypeDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        cniyvArticleTypeService.save(dto);

        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("cniyv:cniyvarticletype:update")
    public Result update(@RequestBody CniyvArticleTypeDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        cniyvArticleTypeService.update(dto);

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("cniyv:cniyvarticletype:delete")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");

        cniyvArticleTypeService.delete(ids);

        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("cniyv:cniyvarticletype:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<CniyvArticleTypeDTO> list = cniyvArticleTypeService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, "文章分类", list, CniyvArticleTypeExcel.class);
    }

}